﻿using Microsoft.AnalysisServices.AdomdClient;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace WA_SSAS
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (Page.IsPostBack == false)
            {
                
                //AdomdConnection conn = new AdomdConnection(@"Provider=MSOLAP.3;Integrated Security=SSPI;Persist Security Info=True;Initial Catalog=AdventureWorksDW2012Multidimensional-EE;Data Source=.");
                AdomdConnection conn = new AdomdConnection(@"Provider=MSOLAP.3;Integrated Security=SSPI;Persist Security Info=True;Initial Catalog=AdventureWorks Tabular Model SQL 2012;Data Source=.\MSBI");
                conn.Open();

                foreach (var CubeItem in conn.Cubes)
                {
                    //Cubes
                    if (CubeItem.Type == CubeType.Cube)
                    {
                        TreeNode tnCube = new TreeNode() { Text = CubeItem.Caption };

                        //Measures
                        TreeNode tnMeasures = new TreeNode() { Text = "Measures", Expanded = false };
                        tnCube.ChildNodes.Add(tnMeasures);
                        foreach (var MeaItem in CubeItem.Measures)
                        {
                            TreeNode tnMeasure = new TreeNode() { Text = MeaItem.Caption };
                            tnMeasures.ChildNodes.Add(tnMeasure);
                        }

                        //Dimensions
                        TreeNode tnDimensions = new TreeNode() { Text = "Dimensions", Expanded = false };
                        tnCube.ChildNodes.Add(tnDimensions);

                        foreach (var DimItem in CubeItem.Dimensions)
                        {
                            TreeNode tnDimension = new TreeNode() { Text = DimItem.Caption, Expanded = false };

                            //Hierarchy
                            foreach (var HieItem in DimItem.Hierarchies)
                            {
                                TreeNode tnHierarchy = new TreeNode() { Text = HieItem.Caption };

                                //Level
                                foreach (var LelItem in HieItem.Levels)
                                {
                                    TreeNode tnLevel = new TreeNode() { Text = LelItem.Caption };
                                    tnHierarchy.ChildNodes.Add(tnLevel);
                                }

                                tnDimension.ChildNodes.Add(tnHierarchy);
                            }

                            tnDimensions.ChildNodes.Add(tnDimension);
                        }

                        TV_SSAS.Nodes.Add(tnCube);
                    }
                }

                conn.Close();
            }
        }
    }
}